/*
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.acroynon.springdatarestexample.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.acroynon.springdatarestexample.client.model.Link;
import com.acroynon.springdatarestexample.client.model.Vehicle;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import com.acroynon.springdatarestexample.client.common.JSON;

/**
 * EntityModelTransport
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen")
public class EntityModelTransport {
  public static final String SERIALIZED_NAME_VEHICLE = "vehicle";
  @SerializedName(SERIALIZED_NAME_VEHICLE)
  private Vehicle vehicle;

  /**
   * Gets or Sets mode
   */
  @JsonAdapter(ModeEnum.Adapter.class)
  public enum ModeEnum {
    OCEAN("OCEAN");

    private String value;

    ModeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static ModeEnum fromValue(String value) {
      for (ModeEnum b : ModeEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<ModeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ModeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public ModeEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return ModeEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_MODE = "mode";
  @SerializedName(SERIALIZED_NAME_MODE)
  private ModeEnum mode;

  public static final String SERIALIZED_NAME_ARRIVAL_PORT_CALL_ID = "arrivalPortCallId";
  @SerializedName(SERIALIZED_NAME_ARRIVAL_PORT_CALL_ID)
  private UUID arrivalPortCallId;

  public static final String SERIALIZED_NAME_DESTINATION_PORT_CALL_ID = "destinationPortCallId";
  @SerializedName(SERIALIZED_NAME_DESTINATION_PORT_CALL_ID)
  private UUID destinationPortCallId;

  public static final String SERIALIZED_NAME_LINKS = "_links";
  @SerializedName(SERIALIZED_NAME_LINKS)
  private Map<String, Link> links = null;

  public EntityModelTransport() { 
  }

  public EntityModelTransport vehicle(Vehicle vehicle) {
    
    this.vehicle = vehicle;
    return this;
  }

   /**
   * Get vehicle
   * @return vehicle
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Vehicle getVehicle() {
    return vehicle;
  }


  public void setVehicle(Vehicle vehicle) {
    this.vehicle = vehicle;
  }


  public EntityModelTransport mode(ModeEnum mode) {
    
    this.mode = mode;
    return this;
  }

   /**
   * Get mode
   * @return mode
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public ModeEnum getMode() {
    return mode;
  }


  public void setMode(ModeEnum mode) {
    this.mode = mode;
  }


  public EntityModelTransport arrivalPortCallId(UUID arrivalPortCallId) {
    
    this.arrivalPortCallId = arrivalPortCallId;
    return this;
  }

   /**
   * Get arrivalPortCallId
   * @return arrivalPortCallId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public UUID getArrivalPortCallId() {
    return arrivalPortCallId;
  }


  public void setArrivalPortCallId(UUID arrivalPortCallId) {
    this.arrivalPortCallId = arrivalPortCallId;
  }


  public EntityModelTransport destinationPortCallId(UUID destinationPortCallId) {
    
    this.destinationPortCallId = destinationPortCallId;
    return this;
  }

   /**
   * Get destinationPortCallId
   * @return destinationPortCallId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public UUID getDestinationPortCallId() {
    return destinationPortCallId;
  }


  public void setDestinationPortCallId(UUID destinationPortCallId) {
    this.destinationPortCallId = destinationPortCallId;
  }


  public EntityModelTransport links(Map<String, Link> links) {
    
    this.links = links;
    return this;
  }

  public EntityModelTransport putLinksItem(String key, Link linksItem) {
    if (this.links == null) {
      this.links = new HashMap<>();
    }
    this.links.put(key, linksItem);
    return this;
  }

   /**
   * Get links
   * @return links
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Map<String, Link> getLinks() {
    return links;
  }


  public void setLinks(Map<String, Link> links) {
    this.links = links;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    EntityModelTransport entityModelTransport = (EntityModelTransport) o;
    return Objects.equals(this.vehicle, entityModelTransport.vehicle) &&
        Objects.equals(this.mode, entityModelTransport.mode) &&
        Objects.equals(this.arrivalPortCallId, entityModelTransport.arrivalPortCallId) &&
        Objects.equals(this.destinationPortCallId, entityModelTransport.destinationPortCallId) &&
        Objects.equals(this.links, entityModelTransport.links);
  }

  @Override
  public int hashCode() {
    return Objects.hash(vehicle, mode, arrivalPortCallId, destinationPortCallId, links);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class EntityModelTransport {\n");
    sb.append("    vehicle: ").append(toIndentedString(vehicle)).append("\n");
    sb.append("    mode: ").append(toIndentedString(mode)).append("\n");
    sb.append("    arrivalPortCallId: ").append(toIndentedString(arrivalPortCallId)).append("\n");
    sb.append("    destinationPortCallId: ").append(toIndentedString(destinationPortCallId)).append("\n");
    sb.append("    links: ").append(toIndentedString(links)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("vehicle");
    openapiFields.add("mode");
    openapiFields.add("arrivalPortCallId");
    openapiFields.add("destinationPortCallId");
    openapiFields.add("_links");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to EntityModelTransport
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (EntityModelTransport.openapiRequiredFields.isEmpty()) {
          return;
        } else { // has required fields
          throw new IllegalArgumentException(String.format("The required field(s) %s in EntityModelTransport is not found in the empty JSON string", EntityModelTransport.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!EntityModelTransport.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `EntityModelTransport` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `vehicle`
      if (jsonObj.getAsJsonObject("vehicle") != null) {
        Vehicle.validateJsonObject(jsonObj.getAsJsonObject("vehicle"));
      }
      if (jsonObj.get("mode") != null && !jsonObj.get("mode").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `mode` to be a primitive type in the JSON string but got `%s`", jsonObj.get("mode").toString()));
      }
      if (jsonObj.get("arrivalPortCallId") != null && !jsonObj.get("arrivalPortCallId").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `arrivalPortCallId` to be a primitive type in the JSON string but got `%s`", jsonObj.get("arrivalPortCallId").toString()));
      }
      if (jsonObj.get("destinationPortCallId") != null && !jsonObj.get("destinationPortCallId").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `destinationPortCallId` to be a primitive type in the JSON string but got `%s`", jsonObj.get("destinationPortCallId").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!EntityModelTransport.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'EntityModelTransport' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<EntityModelTransport> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(EntityModelTransport.class));

       return (TypeAdapter<T>) new TypeAdapter<EntityModelTransport>() {
           @Override
           public void write(JsonWriter out, EntityModelTransport value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public EntityModelTransport read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of EntityModelTransport given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of EntityModelTransport
  * @throws IOException if the JSON string is invalid with respect to EntityModelTransport
  */
  public static EntityModelTransport fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, EntityModelTransport.class);
  }

 /**
  * Convert an instance of EntityModelTransport to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

